/// <reference path="../../headers/common.d.ts" />
System.register(["lodash", "jquery", "app/core/time_series2", "app/plugins/sdk", "app/core/utils/kbn"], function (exports_1, context_1) {
    "use strict";
    var __extends = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var lodash_1, jquery_1, time_series2_1, sdk_1, kbn_1, SSMRangeStatCtrl;
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [
            function (lodash_1_1) {
                lodash_1 = lodash_1_1;
            },
            function (jquery_1_1) {
                jquery_1 = jquery_1_1;
            },
            function (time_series2_1_1) {
                time_series2_1 = time_series2_1_1;
            },
            function (sdk_1_1) {
                sdk_1 = sdk_1_1;
            },
            function (kbn_1_1) {
                kbn_1 = kbn_1_1;
            }
        ],
        execute: function () {/// <reference path="../../headers/common.d.ts" />
            SSMRangeStatCtrl = /** @class */ (function (_super) {
                __extends(SSMRangeStatCtrl, _super);
                /** @ngInject */
                function SSMRangeStatCtrl($scope, $injector, $location, linkSrv) {
                    var _this = _super.call(this, $scope, $injector) || this;
                    _this.$location = $location;
                    _this.linkSrv = linkSrv;
                    // Set and populate defaults
                    _this.panelDefaults = {
                        links: [],
                        datasource: null,
                        maxDataPoints: 100,
                        interval: null,
                        targets: [{}],
                        cacheTimeout: null,
                        format: 'none',
                        nullText: null,
                        valueMaps: [{ value: 'null', op: '=', text: 'N/A' }],
                        mappingTypes: [{ name: 'value to text', value: 1 }, { name: 'range to text', value: 2 }],
                        rangeMaps: [{ from: 'null', to: 'null', text: 'N/A' }],
                        mappingType: 1
                    };
                    lodash_1.default.defaults(_this.panel, _this.panelDefaults);
                    _this.events.on('data-received', _this.onDataReceived.bind(_this));
                    _this.events.on('data-error', _this.onDataError.bind(_this));
                    _this.events.on('data-snapshot-load', _this.onDataReceived.bind(_this));
                    _this.events.on('init-edit-mode', _this.onInitEditMode.bind(_this));
                    return _this;
                }
                SSMRangeStatCtrl.prototype.onInitEditMode = function () {
                    this.addEditorTab('Options', 'public/plugins/ssm-rangestat-panel/editor.html', 2);
                    this.addEditorTab('Value Mappings', 'public/plugins/ssm-rangestat-panel/mappings.html', 3);
                    this.unitFormats = kbn_1.default.getUnitFormats();
                };
                SSMRangeStatCtrl.prototype.setUnitFormat = function (subItem) {
                    this.panel.format = subItem.value;
                    this.refresh();
                };
                SSMRangeStatCtrl.prototype.onDataError = function (err) {
                    this.onDataReceived([]);
                };
                SSMRangeStatCtrl.prototype.onDataReceived = function (dataList) {
                    var data = {};
                    this.series = lodash_1.default.uniqBy(dataList, function (s) { return s.refId; });
                    this.setValues(data);
                    this.data = data;
                    this.render();
                };
                SSMRangeStatCtrl.prototype.seriesHandler = function (seriesData) {
                    var series = new time_series2_1.default({
                        datapoints: seriesData.datapoints || [],
                        alias: seriesData.target
                    });
                    series.refId = seriesData.refId;
                    return series;
                };
                SSMRangeStatCtrl.prototype.setTableColumnToSensibleDefault = function (tableData) {
                    if (this.tableColumnOptions.length === 1) {
                        this.panel.tableColumn = this.tableColumnOptions[0];
                    }
                    else {
                        this.panel.tableColumn = lodash_1.default.find(tableData.columns, function (col) {
                            return col.type !== 'time';
                        }).text;
                    }
                };
                SSMRangeStatCtrl.prototype.getDecimalsForValue = function (value) {
                    if (lodash_1.default.isNumber(this.panel.decimals)) {
                        return { decimals: this.panel.decimals, scaledDecimals: null };
                    }
                    var delta = value / 2;
                    var dec = -Math.floor(Math.log(delta) / Math.LN10);
                    var magn = Math.pow(10, -dec), norm = delta / magn, // norm is between 1.0 and 10.0
                    size;
                    if (norm < 1.5) {
                        size = 1;
                    }
                    else if (norm < 3) {
                        size = 2;
                        // special case for 2.5, requires an extra decimal
                        if (norm > 2.25) {
                            size = 2.5;
                            ++dec;
                        }
                    }
                    else if (norm < 7.5) {
                        size = 5;
                    }
                    else {
                        size = 10;
                    }
                    size *= magn;
                    // reduce starting decimals if not needed
                    if (Math.floor(value) === value) {
                        dec = 0;
                    }
                    var result = {};
                    result.decimals = Math.max(0, dec);
                    result.scaledDecimals = result.decimals - Math.floor(Math.log(size) / Math.LN10) + 2;
                    return result;
                };
                SSMRangeStatCtrl.prototype.setValues = function (data) {
                    data.roundValues = [];
                    data.values = [];
                    data.formattedValues = [];
                    for (var _i = 0, _a = this.series; _i < _a.length; _i++) {
                        var series = _a[_i];
                        var lastPoint = lodash_1.default.last(series.datapoints);
                        var lastValue = lodash_1.default.isArray(lastPoint) ? lastPoint[0] : null;
                        if (lodash_1.default.isString(lastValue)) {
                            data.values.push(0);
                            data.roundValues.push(0);
                            data.formattedValues.push(lodash_1.default.escape(lastValue));
                        }
                        else {
                            data.values.push(lastValue);
                            var decimalInfo = this.getDecimalsForValue(lastValue);
                            var formatFunc = kbn_1.default.valueFormats[this.panel.format];
                            data.formattedValues.push(formatFunc(lastValue, decimalInfo.decimals, decimalInfo.scaledDecimals));
                            data.roundValues.push(kbn_1.default.roundValue(lastValue, decimalInfo.decimals));
                        }
                    }
                    data.scopedVars = lodash_1.default.extend({}, this.panel.scopedVars);
                    this.setValueMapping(data);
                };
                SSMRangeStatCtrl.prototype.setValueMapping = function (data) {
                    if (this.panel.mappingType === 1) {
                        for (var i = 0; i < this.panel.valueMaps.length; i++) {
                            var map = this.panel.valueMaps[i];
                            if (map.value === 'null' && !data.values.length) {
                                data.values = [null];
                                data.roundValues = [null];
                                data.formattedValues = [map.text];
                                return;
                            }
                            for (var i_1 = 0; i_1 < this.series.length; i_1++) {
                                // special null case
                                if (map.value === 'null') {
                                    if (data.values[i_1] === null || data.values[i_1] === void 0) {
                                        data.formattedValues[i_1] = map.text;
                                    }
                                    continue;
                                }
                                // value/number to text mapping
                                var value = parseFloat(map.value);
                                if (value === data.roundValues[i_1]) {
                                    data.formattedValues[i_1] = map.text;
                                    continue;
                                }
                            }
                        }
                    }
                    else if (this.panel.mappingType === 2) {
                        for (var i = 0; i < this.panel.rangeMaps.length; i++) {
                            var map = this.panel.rangeMaps[i];
                            if (map.from === 'null' && map.to === 'null' && !data.values.length) {
                                data.values = [null];
                                data.roundValues = [null];
                                data.formattedValues = [map.text];
                                return;
                            }
                            for (var i_2 = 0; i_2 < this.series.length; i_2++) {
                                // special null case
                                if (map.from === 'null' && map.to === 'null') {
                                    if (data.values[i_2] === null || data.values[i_2] === void 0) {
                                        data.formattedValues[i_2] = map.text;
                                    }
                                    continue;
                                }
                                // value/number to text mapping
                                var from = parseFloat(map.from);
                                var to = parseFloat(map.to);
                                if (to >= data.roundValues[i_2] && from <= data.roundValues[i_2]) {
                                    data.formattedValues[i_2] = map.text;
                                    continue;
                                }
                            }
                        }
                    }
                    //Check data value
                    for (var i = 0; i < this.series.length; i++) {
                        if (data.values[i] === null || data.values[i] === void 0) {
                            data.formattedValues[i] = 'no value';
                        }
                    }
                };
                SSMRangeStatCtrl.prototype.removeValueMap = function (map) {
                    var index = lodash_1.default.indexOf(this.panel.valueMaps, map);
                    this.panel.valueMaps.splice(index, 1);
                    this.render();
                };
                SSMRangeStatCtrl.prototype.addValueMap = function () {
                    this.panel.valueMaps.push({ value: '', op: '=', text: '' });
                };
                SSMRangeStatCtrl.prototype.removeRangeMap = function (rangeMap) {
                    var index = lodash_1.default.indexOf(this.panel.rangeMaps, rangeMap);
                    this.panel.rangeMaps.splice(index, 1);
                    this.render();
                };
                SSMRangeStatCtrl.prototype.addRangeMap = function () {
                    this.panel.rangeMaps.push({ from: '', to: '', text: '' });
                };
                SSMRangeStatCtrl.prototype.link = function (scope, elem, attrs, ctrl) {
                    var $location = this.$location;
                    var linkSrv = this.linkSrv;
                    var $timeout = this.$timeout;
                    var panel = ctrl.panel;
                    var templateSrv = this.templateSrv;
                    var data, linkInfo;
                    elem = elem.find('.ssm-rangestat-panel');
                    function setBigValueHtml() {
                        var initialHeight = elem.height();
                        var initialWidth = elem.width();
                        var content = 'N/A';
                        if (data.formattedValues.length > 1 && data.formattedValues[0] !== data.formattedValues[1]) {
                            var firstIndex = data.formattedValues[0].lastIndexOf(' ');
                            var secondIndex = data.formattedValues[1].lastIndexOf(' ');
                            if (firstIndex !== -1 && secondIndex !== -1 && data.formattedValues[0].slice(firstIndex) === data.formattedValues[1].slice(secondIndex)) {
                                content = data.formattedValues[0].slice(0, firstIndex) + " - " + data.formattedValues[1];
                            }
                            else {
                                content = data.formattedValues[0] + " - " + data.formattedValues[1];
                            }
                        }
                        else if (data.formattedValues.length > 0) {
                            content = data.formattedValues[0];
                        }
                        var fontSize = initialWidth / initialHeight >= 3
                            ? (initialHeight * 0.8)
                            : initialWidth / initialHeight >= 2
                                ? (initialHeight * 0.6)
                                : (initialHeight * 0.4);
                        var body = "<div class=\"ssm-rangestat-panel-value\">" + content + "</div>";
                        elem.html(body);
                        elem.css('font-size', fontSize + "px");
                        do {
                            fontSize = fontSize - 1;
                            elem.css('font-size', fontSize + "px");
                        } while (elem.width() > initialWidth);
                        return body;
                    }
                    function render() {
                        if (!ctrl.data) {
                            return;
                        }
                        data = ctrl.data;
                        // it seems newer Grafana has dropped support of url variables
                        // $__all_variables/$__url_time_range for 3rd-party panel,
                        // hence we add them by our own
                        if (typeof data.scopedVars === 'object') {
                            var scopedAllVariablesStrs = [];
                            for (var key in data.scopedVars) {
                                if (key.indexOf('__') === 0)
                                    continue;
                                scopedAllVariablesStrs.push("var-" + key + "=" + data.scopedVars[key].value);
                            }
                            data.scopedVars['__all_variables'] = {
                                text: '__all_variables',
                                value: scopedAllVariablesStrs.join('&')
                            };
                            if (templateSrv.timeRange) {
                                data.scopedVars['__url_time_range'] = {
                                    text: '__url_time_range',
                                    value: "from=" + templateSrv.timeRange.raw.from + "&to=" + templateSrv.timeRange.raw.to
                                };
                            }
                        }
                        setBigValueHtml();
                        elem.toggleClass('pointer', panel.links.length > 0);
                        if (panel.links.length > 0) {
                            linkInfo = linkSrv.getPanelLinkAnchorInfo(panel.links[0], data.scopedVars);
                        }
                        else {
                            linkInfo = null;
                        }
                    }
                    function hookupDrilldownLinkTooltip() {
                        // drilldown link tooltip
                        var drilldownTooltip = jquery_1.default('<div id="tooltip" class="">hello</div>"');
                        elem.mouseleave(function () {
                            if (panel.links.length === 0) {
                                return;
                            }
                            $timeout(function () {
                                drilldownTooltip.detach();
                            });
                        });
                        elem.click(function (evt) {
                            if (!linkInfo) {
                                return;
                            }
                            // ignore title clicks in title
                            if (jquery_1.default(evt).parents('.panel-header').length > 0) {
                                return;
                            }
                            if (linkInfo.target === '_blank') {
                                window.open(linkInfo.href, '_blank');
                                return;
                            }
                            if (linkInfo.href.indexOf('http') === 0) {
                                window.location.href = linkInfo.href;
                            }
                            else {
                                $timeout(function () {
                                    $location.url(linkInfo.href);
                                });
                            }
                            drilldownTooltip.detach();
                        });
                        elem.mousemove(function (e) {
                            if (!linkInfo) {
                                return;
                            }
                            drilldownTooltip.text('click to go to: ' + linkInfo.title);
                            drilldownTooltip.place_tt(e.pageX, e.pageY - 50);
                        });
                    }
                    hookupDrilldownLinkTooltip();
                    this.events.on('render', function () {
                        render();
                        ctrl.renderingCompleted();
                    });
                };
                SSMRangeStatCtrl.templateUrl = 'module.html';
                return SSMRangeStatCtrl;
            }(sdk_1.MetricsPanelCtrl));
            exports_1("SSMRangeStatCtrl", SSMRangeStatCtrl);
            exports_1("PanelCtrl", SSMRangeStatCtrl);
        }
    };
});
//# sourceMappingURL=module.js.map